app/models/Flowchart.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "flowchart".
 *
 * @property int $id
 * @property string $name
 *
 * @property Node[] $nodes
 */
class Flowchart extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ivr.ivredit_flowchart';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name'], 'required'],
            [['name'], 'unique', 'message' => Yii::t('app', 'Name already exists')],
            [['name'], 'string', 'max' => 50],
        ];
    }


    public function used() {
        return Dialaction::find()
            ->where([
                'event' => 'answer',
                'category' => 'incall',
                'action' => 'ivr',
                'actionarg1' => $this->id
            ])->exists();
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'name' => Yii::t('app', 'Name'),
        ];
    }


    /**
     * @return \yii\db\ActiveQuery
     */
    public function getNodes()
    {
        return $this->hasMany(Node::className(), ['id_flowchart' => 'id']);
    }

    public function getNodecons() {
        return $this->hasMany(Nodecon::className(), ['id_flowchart' => 'id']);
    }
}

app/controllers/FlowchartController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Flowchart;
use app\models\Node;
use app\models\Nodepos;
use app\models\FormNodeprm;
use app\models\PrmForm;

use app\components\DialplanNode;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\Html;

/**
 * FlowchartController implements the CRUD actions for Flowchart model.
 */
class FlowchartController extends Controller
{

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                    ],
                ],
            ]
        ];
    }

    /**
     * Lists all Flowchart models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Flowchart::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }


    /**
     * Creates a new Flowchart model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Flowchart();
        
        if ($model->load(Yii::$app->request->post())) {
            $trans = Yii::$app->db->beginTransaction();
            if ($model->save()) {
                if ($this->makeInitNode($model->id)) {
                    $trans->commit();
                    return $this->redirect(['graph', 'id' => $model->id]);
                }
            }
            $trans->rollback();
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Flowchart model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['index', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Duplicates an existing Flowchart model.
     * If duplication is successful, the browser will be redirected to the 'view' page.
     * @param integer $oldid
     * @paran string $newname
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDuplicate($id)
    {
        $orig = $this->findModelFull($id);
        $copy = new Flowchart();
        $copy->attributes = $orig->attributes;
        $copy->name = '';
        
        if ($copy->load(Yii::$app->request->post())) {
            $ok = true;
            $trans = Yii::$app->db->beginTransaction();

            if ($copy->save()) {
                foreach ($orig->nodes as $n) {
                    unset($n->id);
                    $n->id_flowchart = $copy->id;
                    $n->isNewRecord = true;
                    
                    if (!$n->save()) {
                        $ok = false;
                        break;
                    }
                    
                    $pos = $n->nodepos;
                    $pos->id_node = $n->id;
                    $pos->isNewRecord = true;
                    if (!$pos->save()) {
                        $ok = false;
                        break;
                    }
                    
                    foreach($n->nodeprms as $prm) {
                        unset($prm->id);
                        $prm->id_node = $n->id;
                        $prm->isNewRecord = true;
                        
                        if (!$prm->save()) {
                            $ok = false;
                            break 2;
                        }
                    }
                }                

                if ($ok) {
                    foreach($orig->nodecons as $c) {
                        unset($c->id);
                        $c->id_flowchart = $copy->id;
                        $c->isNewrecord = true;
                        
                        if (!$c->save()) {
                            $ok = false;
                            break;
                        }
                    }
                }
                
            } else {
                $ok = false;
            }       
                                            
            if ($ok) {
                $trans->commit();
                return $this->redirect(['index', 'id' => $copy->id]);
            } else {
                $trans->rollback();
            }
        }
            
        return $this->render('duplicate', [
            'orig' => $orig,
            'copy' => $copy
        ]); 

    }


    /**
     * Deletes an existing Flowchart model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $model = $this->findModel($id);
        if ($model->used()) {
            Yii::$app->session->setFlash('error', Yii::t('app', 'NOT deleted. Flowchart is bind to Incoming call'));
        } else {
            $model->delete();
        }

        return $this->redirect(['index']);
    }


    public function actionGraph($id) {

        $model=$this->findModel($id);

        $list = DialplanNode::enabledNodes();
        $types = [];
        foreach ($list as $t) {
            $c = DialplanNode::typeToClassName($t);
            $types[$t] = array();
            $types[$t]['con'] = $c::optList();
            $types[$t]['title'] = $c::getLabel();
        }

        uasort($types, function($a, $b) {return strcmp($a['title'], $b['title']);});

        return $this->render('graph', [
            'model' => $model,
            'types' => $types
        ]);
    }

        /**
         * Ajax load for graph viewer/editor
         */

    public function actionLoad($id) {
        $this->layout=false;
        Yii::$app->response->format = \yii\web\Response::FORMAT_JSON;

        $model = $this->findModelForGraph($id);
        $nodes = [];
        foreach ($model->nodes as $n) {
            $narr = $n->toArray([], ['nodepos']);
            $narr['name'] = Html::encode($n->realName());
            $nodes[] = $narr;
        } 
            
        return [ 'nodes' => $nodes, 'nodecons' => $model->toArray([], ['nodecons'])['nodecons'] ];
    }



    /**
     * Finds the Flowchart model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Flowchart the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id) {
        $model = Flowchart::findOne($id);
        
        if ($model !== null) {
            return $model;
        }

        throw new NotFoundHttpException(Yii::t('app', 'The requested page does not exist.'));
    }


    public function findModelFull($id) {
        $model = Flowchart::find()->where(['id' => $id])->
            with('nodes','nodes.nodeprms','nodecons','nodes.nodepos')->one();
        if ($model === null)
            throw new NotFoundHttpException(404,'The requested flowchart does not exist.');
        return $model;
    }


    public function findModelForGraph($id) {
        $model = Flowchart::find()->where(['id' => $id])->
            with('nodes','nodecons','nodes.nodepos')->one();
        if ($model === null)
            throw new NotFoundHttpException(404,'The requested flowchart does not exist.');
        return $model;
    }



    private function makeInitNode($id_flowchart) {
        /* DB transaction on calling function expected */
                
        $node = new Node();
        $node->id_flowchart = $id_flowchart;
        $node->node_number = 0;
        $node->node_type = 'start';
        $node->name = 'Start';

        if (!$node->save())
                return false;


        $pos = new Nodepos;
        $pos->id_node = $node->id;
        $pos->x = 250;
        $pos->y = 10;
        
        return $pos->save();
    }
}

app/views/flowchart/_form.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\widgets\ActiveForm;

?>

<div class="flowchart-form">

    <?php $form = ActiveForm::begin(['action' => Url::current()]); ?>


    <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

    <div class="form-group">
        <?= Html::submitButton(Yii::t('app', 'Save'), ['class' => 'btn btn-primary itb-submit']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

app/views/flowchart/_graph.php
<?php

use yii\helpers\Url;
use yii\helpers\Html;
use yii\helpers\Json;

app\assets\GraphAsset::register($this);

if (isset($model->id))
    $this->registerJs("var DialplanID = " . $model->id . ";", Yii\web\View::POS_BEGIN);
else
    $this->registerJs("var DialplanID = 0;", Yii\web\View::POS_BEGIN);

$this->registerJs('                                                           
                yii = {                                                                                                     
                    urls: {                                                                                                 
                        load: '. Json::encode(Url::toRoute('/flowchart/load')).',                                   
                        node_create: '. Json::encode(Url::toRoute('/node/create')).',
                        node_delete: '. Json::encode(Url::toRoute('/node/delete')).',
                        node_update: '. Json::encode(Url::toRoute('/node/update')).',
                        node_parameters: '. Json::encode(Url::toRoute('/node/parameters')).',
                        nodecon_create: '. Json::encode(Url::toRoute('/nodecon/create')).',
                        nodecon_delete: '. Json::encode(Url::toRoute('/nodecon/delete')).',
                        nodecon_move: '. Json::encode(Url::toRoute('/nodecon/move')).',
                        nodepos_update: '. Json::encode(Url::toRoute('/nodepos/update')).',
                        
                        
                    }                                                                                                       
                };
');


$this->registerJs('var NodeType = ' . json_encode($types) . ';',  Yii\web\View::POS_BEGIN);
$this->registerJs("dialplan_init();",  Yii\web\View::POS_READY);



?>


<div id="dialplan">
    <?= $this->render('_menu') ?>
    <div id="flowchart-box">
        <div id="flowchart-header">
                <a href="<?php echo Url::toRoute('index'); ?>"><i class="fa fa-sign-out right"></i></a>
                <h1> <?= Yii::t('app', 'Flowchart ')." ". "'" . $model->name . "'" ?></h1>
        </div>
        <div id="flowchart"></div>
    </div>
</div>

app/views/flowchart/_menu.php
<?php

use kartik\sidenav\SideNav;

function genMenuItem($type, $level) {
    return [
        'label' => Yii::t('node', $type),
        'template' => '{label}',
        'options' => [ 
            'class' => [ 'node-menu-item', 'menu-item-level-' . $level ],
            'type' => $type,
            'onclick' => 'onclickMenuItem(this)'
        ]
    ];
}

?>

<div id="menu">

<?= SideNav::widget([
    'activateItems' => false,
    'encodeLabels' => true,
    'items' => [
        [ 
            'label' => Yii::t('app', 'Call choices'),
            'active' => true,
            'options' => [ 'class' => [ 'node-menu-item', 'node-menu-section' ]],
            'items' => [
                genMenuItem('menu', 2),
                genMenuItem('user', 2),
                genMenuItem('group', 2),
                genMenuItem('queue', 2),
                genMenuItem('voicemail', 2),
                genMenuItem('playback', 2),
                genMenuItem('hangup', 2),
                genMenuItem('goto', 2),
            ],
        ]
    ]
]) ?>

</div>

app/views/flowchart/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Flowchart */


$this->registerCss('/css/xivo.css');

$this->title = Yii::t('app', 'Create Flowchart');

?>
<div class="flowchart-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

app/views/flowchart/duplicate.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Flowchart */

$this->title = Yii::t('app', 'Duplicate Flowchart: {name}', [
    'name' => $orig->name,
]);

?>
<div class="flowchart-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $copy,
    ]) ?>

</div>

app/views/flowchart/graph.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Flowchart */
?>

<div class="flowchart-graph">

    <?= $this->render('_graph', [
        'model' => $model,
        'types' => $types
    ]) ?>

</div>

app/views/flowchart/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Flowcharts');

//$this->registerCssFile('/css/xivo.css');

?>
<div class="flowchart-index">
    <p>
        <?= Html::a('', ['create'], ['class' => 'glyphicon glyphicon-plus btn btn-default btn-action']) ?>
    </p>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'layout' => "{items}\n{pager}",
        'columns' => [
            'id',
            [
                'attribute' => 'name',
                'format' => 'raw',
                'value' => function($model) {
                    return $model->name . '&nbsp;' . Html::a('<span class="glyphicon glyphicon-pencil"></span>', ['update', 'id' => $model->id], [
                        'title' => Yii::t('app', 'Rename'),
                    ]);
                },
                'label' => Yii::t('app', 'Nom'),
            ],
            [
                'class' => 'yii\grid\ActionColumn',
                'header' => Html::a(Yii::t('app', 'Action'), ['index', 'sort' => 'action'], ['data-sort' => 'action']),
                'template' => '{graph} {duplicate} {delete}',
                'buttons' => [
                    'graph' => function($url, $model, $key) {
                        return Html::a('<span class="glyphicon glyphicon-cog"></span>', $url, [
                            'title' => Yii::t('app', 'Configure'),
                        ]);
                    },
                    'duplicate' => function($url, $model, $key) {
                        return Html::a('<span class="glyphicon glyphicon-duplicate"></span>', $url, [
                            'title' => Yii::t('app', 'Duplicate'),
                        ]);
                    },
                    'delete' => function($url, $model, $key) {
                        return Html::a('<span class="glyphicon glyphicon-trash"></span>', $url, [
                            'title' => Yii::t('app', 'Delete'),
                            'data' => [
                                'confirm' => Yii::t('app', 'Do you want to delete this flowchart ?'),
                                'method' => 'post',
                            ],
                        ]);
                    },
                ],
            ],
        ],
    ]); ?>

</div>

app/views/flowchart/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Flowchart */

$this->title = Yii::t('app', 'Update Flowchart: {name}', [
    'name' => $model->name,
]);
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Flowcharts'), 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->name, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = Yii::t('app', 'Update');
?>
<div class="flowchart-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>